<html>

<head>
  <title>Todo App</title>
  <style>
    .hidden {
      display: none;
    }

    ul {
      list-style: none;
      padding: 0;
      margin: 0;
      width: 200px;
    }
  </style>
</head>

<body>
  <form id="form" method="post" action="/create">
    <input type="text" id="description" name="description" />
    <input type="submit" value="Create" />
  </form>
  <div id="error" class="hidden">Something went wrong!</div>
  <ul id="todos">
    {% for todo in todos %}
    <li class="todo-item" id="{{todo.id}}">
      <input class="check-completed" data-id="{{ todo.id }}" type="checkbox" {% if todo.completed %} checked {% endif
        %} />
      {{ todo.description }}
      <input class="delete-todo" data-id="{{ todo.id }}" type="button" value="Delete" />
    </li>
    {% endfor %}
  </ul>
  <script>
    const checkboxes = document.querySelectorAll('.check-completed');
    for (let i = 0; i < checkboxes.length; i++) {
      const checkbox = checkboxes[i];
      checkbox.onchange = function (e) {
        const newCompleted = e.target.checked;
        const todoId = e.target.dataset['id'];
        fetch('/completed', {
          method: 'PATCH',
          body: JSON.stringify({
            'completed': newCompleted,
            'todo_id': todoId,
          }),
          headers: {
            'Content-Type': 'application/json'
          }
        })
          .then(function () {
            document.getElementById('error').className = 'hidden';
          })
          .catch(function () {
            document.getElementById('error').className = '';
          })
      }
    }
    const descInput = document.getElementById('description');
    document.getElementById('form').onsubmit = function (e) {
      e.preventDefault();
      const desc = descInput.value;
      descInput.value = '';
      fetch('/create', {
        method: 'POST',
        body: JSON.stringify({
          'description': desc,
        }),
        headers: {
          'Content-Type': 'application/json',
        }
      })
        .then(response => response.json())
        .then(jsonResponse => {
          const li = document.createElement('li');
          const checkbox = document.createElement('input');
          checkbox.className = 'check-completed';
          checkbox.type = 'checkbox';
          checkbox.setAttribute('data-id', jsonResponse.id);
          li.appendChild(checkbox);

          const text = document.createTextNode(' ' + jsonResponse.description);
          li.appendChild(text);

          const deleteBtn = document.createElement('button');
          deleteBtn.className = 'delete-button';
          deleteBtn.setAttribute('data-id', jsonResponse.id);
          deleteBtn.innerHTML = '&cross;';
          li.appendChild(deleteBtn);

          document.getElementById('todos').appendChild(li);
          document.getElementById('error').className = 'hidden';
        })
        .catch(function () {
          console.error('Error occurred');
          document.getElementById('error').className = '';
        })
    }
    const deleteTodos = document.querySelectorAll(".delete-todo");
    // console.log(deleteTodos.length);
    deleteTodos.forEach(function (button) {
      button.addEventListener('click', function () {
        const todoItem = button.closest('.todo-item');
        console.log(todoItem.id);
        if (todoItem) {
          fetch('/delete', {
            method: 'DELETE',
            body: JSON.stringify({
              'to_delete': todoItem.id,
            }),
            headers: {
              'Content-Type': 'application/json',
            }
          })
            .then(response => response.json())
            .then(jsonResponse => {
              console.log()
              todoItem.remove();
            })
            .catch(function () {
              document.getElementById('error') = '';
            })
        }
      })
    })
  </script>
</body>

</html>